// Copyright (c) 2015 Ryan Prichard
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
// IN THE SOFTWARE.

#include "WinptyVersion.h"

#include <stdio.h>
#include <string.h>

#include "DebugClient.h"

#define XSTRINGIFY(x) #x
#define STRINGIFY(x) XSTRINGIFY(x)

static const char *versionSuffix() {
    const char *ret = STRINGIFY(WINPTY_VERSION_SUFFIX);
    if (!strcmp(ret, "__none__")) {
        return "";
    }
    return ret;
}

void dumpVersionToStdout() {
    printf("winpty version %s%s\n", STRINGIFY(WINPTY_VERSION), versionSuffix());
    printf("commit %s\n", STRINGIFY(WINPTY_COMMIT_HASH));
}

void dumpVersionToTrace() {
    trace("winpty version %s%s (commit %s)",
        STRINGIFY(WINPTY_VERSION),
        versionSuffix(),
        STRINGIFY(WINPTY_COMMIT_HASH));
}
